#include <netdb.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <syslog.h>

int
getpeerinfo( int sock, char *peeraddr, char *peername, size_t len )
{
  int                     size_sa;
  struct  sockaddr_in     sa;
  struct  in_addr         *p_addr;
  struct  hostent         *hp;

  size_sa = sizeof( sa );

  if( getpeername( sock, (struct sockaddr *)&sa, &size_sa ) < 0 ){
    return( -1);
  }
  strncpy( peeraddr, inet_ntoa( sa.sin_addr ), len );
  peeraddr[len - 1] = '\0';

  hp = gethostbyaddr((char *)&sa.sin_addr, sizeof( sa.sin_addr ), AF_INET );
  if( !hp ){ 
    syslog( LOG_ERR, "host lookup failure: %s", peeraddr ); 
    return( -1 );
  }
  else{
    strncpy( peername, hp->h_name, len );
    peername[len - 1] = '\0';
  }

  return( 1 );
}
